/*********************************************************************
*项目名称:MG82F6B08_001_104-DEMO
*			测试板使用 MG82F6B08_001_104 SOP16_V11 EV Board (TH221A)
*			CpuCLK=8MHz, SysCLK=8MHz
*功能描述：
*			IAP 测试
*注意事项：
*
*建立时间:
*修改日志:
*    
*********************************************************************/
#define _MAIN_C

#include <Intrins.h>
#include <Absacc.h>

#include <Stdio.h>  // for printf

#include ".\include\REG_MG82F6B08_001_104.H"
#include ".\include\Type.h"
#include ".\include\API_Macro_MG82F6B08_001_104.H"
#include ".\include\API_Uart_BRGRL_MG82F6B08_001_104.H"


/*************************************************
*定义系统时钟SysClk (MAX.24MHz)
*可选: 
*	8000000,16000000
*	11059200,22118400
*************************************************/
#define MCU_SYSCLK		8000000
/*************************************************/
/*************************************************
*定义CPU时钟 CpuClk (MAX.16MHz)
*	1) CpuCLK=SysCLK
*	2) CpuClk=SysClk/2
*************************************************/
#define MCU_CPUCLK		(MCU_SYSCLK)
//#define MCU_CPUCLK		(MCU_SYSCLK/2)

#define TIMER_1T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) /256) 			
#define TIMER_1T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(1000000)))) %256)

#define TIMER_12T_1ms_TH	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) /256) 			
#define TIMER_12T_1ms_TL	((65536-(u16)(float)(1000*((float)(MCU_SYSCLK)/(float)(12000000)))) %256)

#define LED_R		P32
#define LED_G_0		P33
#define LED_G_1		P46

#define IO_KEY_SAVE_0			P10
#define IO_KEY_SAVE_1			P30


#define ERR_CNT_MAX		4		// 错误重试计数最大值


#define ISP_ADDRESS    0x1A00	 //ISP起始地址 
#define IAP_ADDRESS    0x1600	 //IAP起始地址  
idata u8 TrapFlag[3];

#define TEST_WRITE_BUF_IAP_ADDRESS_0    0x1600	 // 测试写Buf到IAP的起始地址
#define TEST_WRITE_BUF_IAP_ADDRESS_1    0x1610	 // 测试写Buf到IAP的起始地址
xdata u8 TestBuf[16];

/*************************************************
*函数名称: char putchar (char c)   
*功能描述: 用于printf 的串口输出程序
*输入参数:     char c
*返回参数:     
*************************************************/
char putchar (char c)   
{      
	bit bES;
	bES=ES0;
    ES0=0;        
    S0BUF = c;        
    while(TI0==0);        
    TI0=0;        
    ES0=bES;        
    return 0;
}

/*************************************************
*函数名称:     void DelayXus(u8 xUs)
*功能描述:   	延时程序，单位为us
*输入参数:     u8 Us -> *1us  (1~255)
*返回参数:     
*************************************************/
void DelayXus(u8 xUs)
{
	while(xUs!=0)
	{
#if (MCU_CPUCLK>=11059200)
		_nop_();
#endif
#if (MCU_CPUCLK>=14745600)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=16000000)
		_nop_();
#endif

#if (MCU_CPUCLK>=22118400)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=24000000)
		_nop_();
		_nop_();
#endif		
#if (MCU_CPUCLK>=29491200)
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
		_nop_();
#endif
#if (MCU_CPUCLK>=32000000)
		_nop_();
		_nop_();
#endif

		xUs--;
	}
}

/*************************************************
*函数名称:     void DelayXms(u16 xMs)
*功能描述:     延时程序，单位为ms
*输入参数:     u16 xMs -> *1ms  (1~65535)
*返回参数:     
*************************************************/
void DelayXms(u16 xMs)
{
	while(xMs!=0)
	{
		CLRWDT();
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		DelayXus(200);
		xMs--;
		
	}
}

/***********************************************************************************
*函数名称:   	void CheckTrapFlag(void)
*功能描述:   	检查是否按正确的流程进入IAP操作，防止误操作
*			如果TrapFlag != 'Win',则表示是非法进入,单片机软复位
*输入参数:   	
*返回参数:     
*************************************************************************************/
void CheckTrapFlag(void)
{ 
	if ((TrapFlag[0]!='W')||(TrapFlag[1]!='i')||(TrapFlag[2]!='n'))
	{
		//软件复位
	//	POW_ResetToAP();
	}
}

/***********************************************************************************
*函数名称:   u8 IAP_ReadPPage(u8 PsfrAddr)
*功能描述:读取P页特殊功能器内容
*输入参数:u8 PsfrAddr: P页地址   
*返回参数:u8: P页内容     
*************************************************************************************/
u8 IAP_ReadPPage(u8 PsfrAddr)
{
	bit bEA=EA;
	EA = 0; 					//关中断
	IFADRH = 0; 				//IFADRH必须为0
	IFADRL= PsfrAddr;			//送P页地址;
	IFMT = ISP_READ_P;
	ISPCR = 0x80;				//设置等待时间, 允许ISP/IAP操作
//	CheckTrapFlag();
	SCMD = 0x46;
//	CheckTrapFlag();
	SCMD = 0xB9;
	nop();
	IFMT=0;
	ISPCR = 0;					//清ISP/IAP特殊寄存器，防止误操作
	EA = bEA;					//恢复中断
	return IFD;
}

/***********************************************************************************
*函数名称:void IAP_WritePPage(u8 PsfrAddr,u8 PsfrData)
*功能描述:写P页特殊功能器
*输入参数:u8 PsfrAddr: P页地址,u8 PsfrData:  P页内容   
*返回参数:     
*************************************************************************************/
void IAP_WritePPage(u8 PsfrAddr,u8 PsfrData)
{
	bit bEA=EA;
	EA = 0; 					//关中断
	IFADRH = 0; 				//IFADRH必须为0
	IFADRL= PsfrAddr;			//送P页地址;
	IFD= PsfrData;				//送P页内容
	IFMT = ISP_WRITE_P;
	ISPCR = 0x80;				//设置等待时间, 允许ISP/IAP操作
//	CheckTrapFlag();
	SCMD = 0x46;
//	CheckTrapFlag();
	SCMD = 0xB9;
	nop();
	IFMT=0;
	ISPCR = 0;					//清ISP/IAP特殊寄存器，防止误操作
	EA = bEA;					//恢复中断
}

/***********************************************************************************
*函数名称:u8 IAP_ReadByte(u16 ByteAddr)
*功能描述:读指定地址的IAP内容
*输入参数:u16 ByteAddr: IAP地址   
*返回参数:     
*************************************************************************************/
u8 IAP_ReadByte(u16 ByteAddr)
{
		bit bEA=EA;
		IFADRH = ByteAddr>>8;		//送地址高字节
		IFADRL= (u8)(ByteAddr);			//送地址低字节;
		EA = 0;						//关中断
		IFMT = ISP_READ;
		ISPCR = 0x80; 				//允许ISP/IAP操作
//		CheckTrapFlag();
		SCMD = 0x46;
//		CheckTrapFlag();
		SCMD = 0xB9;
		IFMT=0;
		ISPCR = 0;					//清ISP/IAP特殊寄存器，防止误操作
		EA = bEA; 					//恢复中断
		return IFD;
}
// 可以使用MOVC的方式读取IAP的数据
#define	IAP_ReadByteByMOVC(x)	CBYTE[x]

/***********************************************************************************
*函数名称:void IAP_ErasePage(u16 ByteAddr)
*功能描述:页面擦除, 擦除指定地址所在的页面。
*输入参数:u8 ByteAddr: 指定的页面地址高8位   
*************************************************************************************/
void IAP_ErasePage(u16 ByteAddr)
{
		bit bEA=EA;
		IFADRH = (u8)(ByteAddr>>8);				//送地址高字节
		IFADRL= (u8)(ByteAddr)&B11000000;		//送地址低字节;
		EA = 0;									//关中断
		IFMT = ISP_ERASE;
		ISPCR = 0x80; 							//允许ISP/IAP操作
//		CheckTrapFlag();
		SCMD = 0x46;
//		CheckTrapFlag();
		SCMD = 0xB9;
		nop();
		IFMT=0;
		ISPCR = 0;								//清ISP/IAP特殊寄存器，防止误操作
		EA = bEA; 								//恢复中断
}

/***********************************************************************************
*函数名称:		u8 IAP_WriteBuf_With_Protect_Verify(u16 ByteAddr,u8 *pBuf,u8 Cnt)
*功能描述:		写一串数据到IAP指定地址,并校验.如果校验失败,则重写.重写超过最大次数,则返回失败.
*		 	会使用到64字节XDATA保存扇区原有数据
*输入参数:  u16 ByteAddr: 指定的IAP地址, u8 *pBuf: 待写入数据Buf地址，u8 Cnt: 待写入个数(<64) 
*返回参数:u8 0：成功,	other:失败     
*************************************************************************************/
u8 IAP_WriteBuf_With_Verify_Protect(u16 ByteAddr,u8 *pBuf,u8 Cnt)
{
		xdata u8 TempBuf[64];
		u16 i;
		u8 ErrCnt;
		WordTypeDef SectorAddr;
		bit bEA=EA;

		// 读取待烧录扇区原有数据到临时缓冲
		ErrCnt=0;
		
		SectorAddr.W=ByteAddr&0xFFC0;
		for(i=0;i<64;i++)
		{
			TempBuf[i]=IAP_ReadByte(SectorAddr.W);
			SectorAddr.W++;
		}
		// 更改需写入的数据
		i=ByteAddr&0x003F;
		while(Cnt!=0)
		{
			TempBuf[i]=*pBuf;
			pBuf++;
			i++;
			Cnt--;
		}
	P_Err_Loop:
		// 擦除扇区
		SectorAddr.W=ByteAddr&0xFE00;
		IAP_ErasePage(SectorAddr.W);
		
		// 将更改后的数据写入IAP		
		EA = 0;								//关中断
		
		ISPCR = 0x80;               		//允许ISP/IAP操作
		IFMT = ISP_BYTE_WRITE;				// 字节写模式
		
		for(i=0;i<64;i++)
		{
			IFADRH= SectorAddr.B.BHigh;		//送地址高字节
			IFADRL= SectorAddr.B.BLow; 		//送地址低字节;
			IFD = TempBuf[i]; 				//送所要写的数据 
			//		CheckTrapFlag();
			SCMD = 0x46;
			//		CheckTrapFlag();
			SCMD = 0xB9;
			nop();
			SectorAddr.W++;
		}
		IFMT = ISP_PAGE_WRITE;				// 页面写模式
		//CheckTrapFlag();
		SCMD = 0x46;
		//CheckTrapFlag();
		SCMD = 0xB9;
		nop();
		IFMT=0;
		ISPCR = 0;							//清ISP/IAP特殊寄存器，防止误操作

		EA = bEA; 							//恢复中断

		// 校验数据是否正确
		SectorAddr.W=ByteAddr&0xFFC0;
		for(i=0;i<64;i++)
		{
			if(TempBuf[i]!=IAP_ReadByte(SectorAddr.W))
			{
				ErrCnt++;
				if(ErrCnt<ERR_CNT_MAX)
				{
					goto P_Err_Loop;
				}
				else
				{
					goto P_Err_Return;
				}
			}
			SectorAddr.W++;
		}
		ErrCnt=0;
	P_Err_Return:
		return ErrCnt;		
}

/***********************************************************************************
*函数名称:		u8 IAP_WriteBuf_With_Verify(u16 ByteAddr,u8 *pBuf,u8 Cnt)
*功能描述:		写一串数据到IAP指定地址,并校验.如果校验失败,则重写.重写超过最大次数,则返回失败.
*		 	不保护IAP原有数据
*输入参数:u16 ByteAddr: 指定的IAP地址, u8 *pBuf: 待写入数据Buf地址，u8 Cnt: 待写入个数(<64) 
*返回参数:u8 0：成功,	other:失败     
*************************************************************************************/
u8 IAP_WriteBuf_With_Verify(u16 ByteAddr,u8 *pBuf,u8 Cnt)
{
		u16 i;
		u8 ErrCnt;
		WordTypeDef SectorAddr;

		bit bEA=EA;

		ErrCnt=0;
		
	Err_Loop:
		// 擦除扇区
		SectorAddr.W=ByteAddr;
		IAP_ErasePage(SectorAddr.W);

		// 将更改后的数据写入IAP		
		EA = 0;								//关中断
		
		ISPCR = 0x80;               		//允许ISP/IAP操作
		IFMT = ISP_BYTE_WRITE;				// 字节写模式
		
		// 将数据写入IAP		
		for(i=0;i<Cnt;i++)
		{
			IFADRH= SectorAddr.B.BHigh;		//送地址高字节
			IFADRL= SectorAddr.B.BLow; 		//送地址低字节;
			IFD = pBuf[i]; 					//送所要写的数据 
			//		CheckTrapFlag();
			SCMD = 0x46;
			//		CheckTrapFlag();
			SCMD = 0xB9;
			nop();
			SectorAddr.W++;
		}
		IFMT = ISP_PAGE_WRITE;				// 页面写模式
		//CheckTrapFlag();
		SCMD = 0x46;
		//CheckTrapFlag();
		SCMD = 0xB9;
		nop();
		IFMT=0;
		ISPCR = 0;							//清ISP/IAP特殊寄存器，防止误操作

		EA = bEA; 							//恢复中断

		// 校验数据是否正确
		SectorAddr.W=ByteAddr;
		for(i=0;i<Cnt;i++)
		{
			if(pBuf[i]!=IAP_ReadByte(SectorAddr.W))
			{
				ErrCnt++;
				if(ErrCnt<ERR_CNT_MAX)
				{
					goto Err_Loop;
				}
				else
				{
					goto Err_Return;
				}
			}
			SectorAddr.W++;
		}
		ErrCnt=0;
	Err_Return:
		return ErrCnt;		
}

/***********************************************************************************
*函数名称:   void InitUart0_S0BRG(void)
*功能描述:   Uart0初始化 使用S0BRG作为波特率来源
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitUart0_S0BRG(void)
{
	UART0_SetAccess_S0CR1();			// 设置SFR 0xB9地址是访问S0CR1
	UART0_SetMode8bitUARTVar();			// 8位 可变波特率
	UART0_EnReception();				// 使能接收
	UART0_SetBRGFromS0BRG();			// 设置波特率来源为 S0BRG
	UART0_SetS0BRGBaudRateX2();			// 设置2x波特率
	UART0_SetS0BRGSelSYSCLK();			// 设置S0BRG时钟输入为Sysclk
	UART0_SetRxTxP30P31();
	// Sets B.R. value
	UART0_SetS0BRGValue(S0BRG_BRGRL_9600_2X_8000000_1T);

	UART0_EnS0BRG();					// 开启S0BRG时钟
}

/***********************************************************************************
*函数名称:   void InitPort(void)
*功能描述:   IO配置
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitPort(void)
{
	PORT_SetP3QuasiBi(BIT0|BIT1|BIT2|BIT3);		// 设置 P30,P31,P32,P33为双向口,用于RXD/TXD,LED
	PORT_SetP4OpenDrainPu(BIT6);				// 设置 P46为开漏带上拉,用于LED
	
	PORT_SetP1OpenDrainPu(BIT0);				// 设置 P10为开漏带上拉
	P10=1;
	P30=1;
}


/***********************************************************************************
*函数名称:   void InitClock(void)
*功能描述:   时钟初始化	
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitClock(void)
{
#if (MCU_SYSCLK==8000000)
	// Default: IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
#endif

#if (MCU_SYSCLK==11059200)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK/2
	CLK_SelIHRCO_22118400Hz();
#endif
	
#if (MCU_SYSCLK==16000000)
	// IHRCO=16MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif

#if (MCU_SYSCLK==22118400)
	// IHRCO=22.12MHz, OSCin=IHRCO,MCK=OSCin,MCKDO=MCK
	CLK_SelIHRCO_22118400Hz();
	CLK_SetCKCON3(WDTCS_ILRCO|FWKP_NORMAL_120uS|MCKDO_MCK_DIV_1);
#endif
	

#if (MCU_CPUCLK==MCU_SYSCLK)
	CLK_SetCpuclk_Sysclk();
#else
	CLK_SetCpuclk_SysclkDiv2();
#endif

	// P45 输出 MCK/4
	//CLK_P45OC_MCKDiv4();
}



/***********************************************************************************
*函数名称:   void InitSystem(void)
*功能描述:   系统初始化
*输入参数:   
*返回参数:     
*************************************************************************************/
void InitSystem(void)
{
	InitPort();
	InitClock();
	InitUart0_S0BRG();	
	TrapFlag[1]='i';
}




void main()
{
	u8 IAPData;
	u8 i;
	u8 rand;
	bit bOK=TRUE;

	TrapFlag[0]='W';
	
    InitSystem();
    
	LED_G_0=0;LED_G_1=0;LED_R=0;
	DelayXms(1000);
	printf("\nStart IAP DEMO!");
	LED_G_0=1;LED_G_1=1;LED_R=1;

	TrapFlag[2]='n';
	//读IAP初始起始地址
	i=IAP_ReadPPage(IAPLB_P);
    printf("\nRead IAPLB:%02bX",i);

	// 设置IAP起始地址为ISP地址,即无IAP空间
	IAP_WritePPage(IAPLB_P,ISP_ADDRESS/256);
	i=IAP_ReadPPage(IAPLB_P);
    printf("\nNOW IAPLB:%02bX\n",i);
	TrapFlag[2]=0xFF;

	printf("\nOld IAP %04X:\n",IAP_ADDRESS);
	i=0;
	do{
		LED_G_1=0;
		IAPData=IAP_ReadByteByMOVC(IAP_ADDRESS+i);	// 用MOVC的方式读取数据
		LED_G_1=1;
		printf("%02bX ",IAPData);
		if((i&0x0F)==0x0F)
		{
			printf("\n");
		}
		i++;
	}while(i<64);
    

    while(1)
    {
    	rand++;
		LED_G_0=!LED_G_0;
	   	DelayXms(100);
		if(IO_KEY_SAVE_0==0)
		{
			DelayXms(50);
			if(IO_KEY_SAVE_0==0)
			{

				// 准备要写入的数据
				for(i=0;i<16;i++)
				{
					TestBuf[i]=rand+i;
				}
				
				TrapFlag[2]='n';
				
				// 设置IAP起始地址为欲操作的IAP地址
				printf("\nWrite IAPLB:%02bX  ",IAP_ADDRESS/256);
				IAP_WritePPage(IAPLB_P,IAP_ADDRESS/256);
				i=IAP_ReadPPage(IAPLB_P);
				printf("\nRead IAPLB:%02bX  ",i);

				// 将数据写IAP,保护其它数据
				printf("\nWrit IAP %04X...  ",TEST_WRITE_BUF_IAP_ADDRESS_0);
				if(IAP_WriteBuf_With_Verify_Protect(TEST_WRITE_BUF_IAP_ADDRESS_0, &TestBuf[0], 16)==0)
				{// 成功
					bOK=TRUE;
					printf("OK!!");
				}
				else
				{// 失败
					bOK=FALSE;
					printf("FAIL!!");
				}
				
				// 设置IAP起始地址为ISP地址,即无IAP空间
				printf("\nWrite IAPLB:%02bX  ",ISP_ADDRESS/256);
				IAP_WritePPage(IAPLB_P,ISP_ADDRESS/256);
				i=IAP_ReadPPage(IAPLB_P);
				printf("\nRead IAPLB:%02bX  ",i);
				TrapFlag[2]=0xFF;
				
				if(bOK)
				{// 成功
					for(i=0;i<10;i++)
					{
						LED_G_0=0;
						DelayXms(30);
						LED_G_0=1;
						DelayXms(30);
					}
				}
				else
				{// 失败
					LED_R=0;
					DelayXms(500);
					LED_R=1;
				}

				// 等待按键松开 
				while(IO_KEY_SAVE_0==0)
				{
					DelayXms(50);
				}
			}
		}

		if(IO_KEY_SAVE_1==0)
		{
			DelayXms(50);
			if(IO_KEY_SAVE_1==0)
			{

				// 准备要写入的数据
				for(i=0;i<16;i++)
				{
					TestBuf[i]=rand+i;
				}
				
				TrapFlag[2]='n';
				
				// 设置IAP起始地址为欲操作的IAP地址
				printf("\nWrite IAPLB:%02bX  ",IAP_ADDRESS/256);
				IAP_WritePPage(IAPLB_P,IAP_ADDRESS/256);
				i=IAP_ReadPPage(IAPLB_P);
				printf("\nRead IAPLB:%02bX  ",i);

				// 将数据写IAP,不保护其它数据
				printf("\nWrit IAP %04X...  ",TEST_WRITE_BUF_IAP_ADDRESS_1);
				if(IAP_WriteBuf_With_Verify(TEST_WRITE_BUF_IAP_ADDRESS_1, &TestBuf[0], 16)==0)
				{// 成功
					bOK=TRUE;
					printf("OK!!");
				}
				else
				{// 失败
					bOK=FALSE;
					printf("FAIL!!");
				}
				
				// 设置IAP起始地址为ISP地址,即无IAP空间
				printf("\nWrite IAPLB:%02bX  ",ISP_ADDRESS/256);
				IAP_WritePPage(IAPLB_P,ISP_ADDRESS/256);
				i=IAP_ReadPPage(IAPLB_P);
				printf("\nRead IAPLB:%02bX  ",i);
				TrapFlag[2]=0xFF;
				
				if(bOK)
				{// 成功
					for(i=0;i<10;i++)
					{
						LED_G_0=0;
						DelayXms(30);
						LED_G_0=1;
						DelayXms(30);
					}
				}
				else
				{// 失败
					LED_R=0;
					DelayXms(500);
					LED_R=1;
				}

				// 等待按键松开 
				while(IO_KEY_SAVE_1==0)
				{
					DelayXms(50);
				}
			}
		}

		
    }

}


